/*
 * main.c
 *
 *  Created on: 2013-09-16
 *       Autor: Jaglasty
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "MKUART/mkuart.h"

#define SR 8

typedef struct{
	uint16_t adc_mid;

} TVOL;


uint16_t pomiar( uint8_t kanal );


#define REF_256 (1<<REFS1) | (1<<REFS0); // wybr napicia vref 2,56

uint8_t srednia1, srednia2, srednia3;

int main (void){

	//inicjalizacja ADC
	ADCSRA |= (1<<ADEN); //wczanie ADC
	ADCSRA |= (1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0); //prescaler 128
	ADMUX |= REF_256;	//napiecie odniesienia


	USART_Init( __UBRR );

	uint16_t wynik1=0;  //zmienna przechowujaca pomiar z kanalu PC0
	uint16_t wynik2=0;  //zmienna przechowujaca pomiar z kanalu PC1
	uint16_t wynik3=0;  //zmienna przechowujaca pomiar z kanalu PC2




	sei();	/* wczamy globalne przerwania */


	while(1){

						wynik1 = pomiar( PC0 );
						uart_putint(wynik1, 10);  //pobranie i wyswietlenie 1 kanalu

						uart_puts(",");	/* wywietl odstep */

						wynik2 = pomiar( PC1 );
						uart_putint(wynik2, 10);  //pobranie i wyswietlenie 2 kanalu

						uart_puts(",");	/* wywietl odstep */

						wynik3 = pomiar( PC2 );
						uart_putint(wynik3, 10);  //pobranie i wyswietlenie 3 kanalu






						uart_putc('\n');			// wyślij znak LF (nowa linia)
						_delay_ms(600);


	}
}

uint16_t pomiar( uint8_t kanal ) {
	ADMUX = (ADMUX & 0b11111000) | kanal;
	ADCSRA |= (1<<ADSC); //start kowersji
	while( ADCSRA & (1<<ADSC) );
	return ADCW;

	}


